<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.interface_micro_impl</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;interface_micro_impl
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.interface_micro_impl-module.html">Module pyxmpp.interface_micro_impl</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2006 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-docstring">"""Interface API, minimal implementation.</tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-docstring">This is minimal Zope Interfaces API implementation, as required by PyXMPP, not add another dependencies.</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-docstring">If zope.interface package is available it will be used instead of this one. Never import this module directly."""</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">sys</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">types</tt> <tt class="py-keyword">import</tt> <tt class="py-name">FunctionType</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"> </tt>
<a name="classImplements"></a><div id="classImplements-def"><a name="L29"></a><tt class="py-lineno"> 29</tt> <a class="py-toggle" href="#" id="classImplements-toggle" onclick="return toggle('classImplements');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl-module.html#classImplements">classImplements</a><tt class="py-op">(</tt><tt class="py-param">cls</tt><tt class="py-op">,</tt> <tt class="py-op">*</tt><tt class="py-param">interfaces</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="classImplements-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="classImplements-expanded"><a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">cls</tt><tt class="py-op">,</tt> <tt class="py-name">classobj</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line">        <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">"%r is not a class"</tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt id="link-0" class="py-name" targets="Module pyxmpp.interface=pyxmpp.interface-module.html,Variable zope.interface.interface.Attribute.interface=zope.interface.interface.Attribute-class.html#interface"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-0', 'interface', 'link-0');">interface</a></tt> <tt class="py-keyword">in</tt> <tt id="link-1" class="py-name" targets="Module pyxmpp.interfaces=pyxmpp.interfaces-module.html"><a title="pyxmpp.interfaces" class="py-name" href="#" onclick="return doclink('link-1', 'interfaces', 'link-1');">interfaces</a></tt><tt class="py-op">:</tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt id="link-2" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-2', 'interface', 'link-0');">interface</a></tt><tt class="py-op">,</tt> <tt id="link-3" class="py-name" targets="Class pyxmpp.interface_micro_impl.InterfaceClass=pyxmpp.interface_micro_impl.InterfaceClass-class.html"><a title="pyxmpp.interface_micro_impl.InterfaceClass" class="py-name" href="#" onclick="return doclink('link-3', 'InterfaceClass', 'link-3');">InterfaceClass</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">"Only interfaces may be implemented"</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line">    <tt class="py-name">cls</tt><tt class="py-op">.</tt><tt id="link-4" class="py-name" targets="Variable zope.interface.interface.Attribute.__implemented__=zope.interface.interface.Attribute-class.html#__implemented__"><a title="zope.interface.interface.Attribute.__implemented__" class="py-name" href="#" onclick="return doclink('link-4', '__implemented__', 'link-4');">__implemented__</a></tt> <tt class="py-op">=</tt> <tt class="py-name">tuple</tt><tt class="py-op">(</tt><tt id="link-5" class="py-name"><a title="pyxmpp.interfaces" class="py-name" href="#" onclick="return doclink('link-5', 'interfaces', 'link-1');">interfaces</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"> </tt>
<a name="implements"></a><div id="implements-def"><a name="L37"></a><tt class="py-lineno"> 37</tt> <a class="py-toggle" href="#" id="implements-toggle" onclick="return toggle('implements');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl-module.html#implements">implements</a><tt class="py-op">(</tt><tt class="py-op">*</tt><tt class="py-param">interfaces</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="implements-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="implements-expanded"><a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt id="link-6" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-6', 'interface', 'link-0');">interface</a></tt> <tt class="py-keyword">in</tt> <tt id="link-7" class="py-name"><a title="pyxmpp.interfaces" class="py-name" href="#" onclick="return doclink('link-7', 'interfaces', 'link-1');">interfaces</a></tt><tt class="py-op">:</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt id="link-8" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-8', 'interface', 'link-0');">interface</a></tt><tt class="py-op">,</tt> <tt id="link-9" class="py-name"><a title="pyxmpp.interface_micro_impl.InterfaceClass" class="py-name" href="#" onclick="return doclink('link-9', 'InterfaceClass', 'link-3');">InterfaceClass</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">"Only interfaces may be implemented"</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line">    <tt class="py-name">frame</tt> <tt class="py-op">=</tt> <tt class="py-name">sys</tt><tt class="py-op">.</tt><tt class="py-name">_getframe</tt><tt class="py-op">(</tt><tt class="py-number">1</tt><tt class="py-op">)</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line">    <tt class="py-name">locals</tt> <tt class="py-op">=</tt> <tt class="py-name">frame</tt><tt class="py-op">.</tt><tt class="py-name">f_locals</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-op">(</tt><tt class="py-name">locals</tt> <tt class="py-keyword">is</tt> <tt class="py-name">frame</tt><tt class="py-op">.</tt><tt class="py-name">f_globals</tt><tt class="py-op">)</tt> <tt class="py-keyword">or</tt> <tt class="py-op">(</tt><tt class="py-string">'__module__'</tt> <tt class="py-keyword">not</tt> <tt class="py-keyword">in</tt> <tt class="py-name">locals</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line">        <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">"implements() may only be used in a class definition"</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"> </tt>
<a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-string">"__implemented__"</tt> <tt class="py-keyword">in</tt> <tt class="py-name">locals</tt><tt class="py-op">:</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">        <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">"implements() may be used only once"</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line">    <tt class="py-name">locals</tt><tt class="py-op">[</tt><tt class="py-string">"__implemented__"</tt><tt class="py-op">]</tt> <tt class="py-op">=</tt> <tt class="py-name">tuple</tt><tt class="py-op">(</tt><tt id="link-10" class="py-name"><a title="pyxmpp.interfaces" class="py-name" href="#" onclick="return doclink('link-10', 'interfaces', 'link-1');">interfaces</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"> </tt>
<a name="_whole_tree"></a><div id="_whole_tree-def"><a name="L53"></a><tt class="py-lineno"> 53</tt> <a class="py-toggle" href="#" id="_whole_tree-toggle" onclick="return toggle('_whole_tree');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl-module.html#_whole_tree">_whole_tree</a><tt class="py-op">(</tt><tt class="py-param">cls</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="_whole_tree-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="_whole_tree-expanded"><a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line">    <tt class="py-keyword">yield</tt> <tt class="py-name">cls</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt class="py-name">base</tt> <tt class="py-keyword">in</tt> <tt class="py-name">cls</tt><tt class="py-op">.</tt><tt id="link-11" class="py-name" targets="Variable pyxmpp.interfaces.IFeaturesProvider.__bases__=pyxmpp.interfaces.IFeaturesProvider-class.html#__bases__,Variable pyxmpp.interfaces.IIqHandlersProvider.__bases__=pyxmpp.interfaces.IIqHandlersProvider-class.html#__bases__,Variable pyxmpp.interfaces.IMessageHandlersProvider.__bases__=pyxmpp.interfaces.IMessageHandlersProvider-class.html#__bases__,Variable pyxmpp.interfaces.IPresenceHandlersProvider.__bases__=pyxmpp.interfaces.IPresenceHandlersProvider-class.html#__bases__,Variable pyxmpp.interfaces.IPyXMPPHelper.__bases__=pyxmpp.interfaces.IPyXMPPHelper-class.html#__bases__,Variable pyxmpp.interfaces.IStanzaHandlersProvider.__bases__=pyxmpp.interfaces.IStanzaHandlersProvider-class.html#__bases__,Variable zope.interface.Interface.__bases__=zope.interface.Interface-class.html#__bases__"><a title="pyxmpp.interfaces.IFeaturesProvider.__bases__
pyxmpp.interfaces.IIqHandlersProvider.__bases__
pyxmpp.interfaces.IMessageHandlersProvider.__bases__
pyxmpp.interfaces.IPresenceHandlersProvider.__bases__
pyxmpp.interfaces.IPyXMPPHelper.__bases__
pyxmpp.interfaces.IStanzaHandlersProvider.__bases__
zope.interface.Interface.__bases__" class="py-name" href="#" onclick="return doclink('link-11', '__bases__', 'link-11');">__bases__</a></tt><tt class="py-op">:</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">b</tt> <tt class="py-keyword">in</tt> <tt id="link-12" class="py-name" targets="Function pyxmpp.interface_micro_impl._whole_tree()=pyxmpp.interface_micro_impl-module.html#_whole_tree"><a title="pyxmpp.interface_micro_impl._whole_tree" class="py-name" href="#" onclick="return doclink('link-12', '_whole_tree', 'link-12');">_whole_tree</a></tt><tt class="py-op">(</tt><tt class="py-name">base</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line">            <tt class="py-keyword">yield</tt> <tt class="py-name">b</tt> </tt>
</div><a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"> </tt>
<a name="implementedBy"></a><div id="implementedBy-def"><a name="L59"></a><tt class="py-lineno"> 59</tt> <a class="py-toggle" href="#" id="implementedBy-toggle" onclick="return toggle('implementedBy');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl-module.html#implementedBy">implementedBy</a><tt class="py-op">(</tt><tt class="py-param">cls</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="implementedBy-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="implementedBy-expanded"><a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line">    <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt id="link-13" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-13', 'interface', 'link-0');">interface</a></tt> <tt class="py-keyword">in</tt> <tt class="py-name">cls</tt><tt class="py-op">.</tt><tt id="link-14" class="py-name"><a title="zope.interface.interface.Attribute.__implemented__" class="py-name" href="#" onclick="return doclink('link-14', '__implemented__', 'link-4');">__implemented__</a></tt><tt class="py-op">:</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">c</tt> <tt class="py-keyword">in</tt> <tt id="link-15" class="py-name"><a title="pyxmpp.interface_micro_impl._whole_tree" class="py-name" href="#" onclick="return doclink('link-15', '_whole_tree', 'link-12');">_whole_tree</a></tt><tt class="py-op">(</tt><tt id="link-16" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-16', 'interface', 'link-0');">interface</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line">                <tt class="py-keyword">yield</tt> <tt class="py-name">c</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">    <tt class="py-keyword">except</tt> <tt class="py-name">AttributeError</tt><tt class="py-op">:</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">        <tt class="py-keyword">pass</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt class="py-name">base</tt> <tt class="py-keyword">in</tt> <tt class="py-name">cls</tt><tt class="py-op">.</tt><tt id="link-17" class="py-name"><a title="pyxmpp.interfaces.IFeaturesProvider.__bases__
pyxmpp.interfaces.IIqHandlersProvider.__bases__
pyxmpp.interfaces.IMessageHandlersProvider.__bases__
pyxmpp.interfaces.IPresenceHandlersProvider.__bases__
pyxmpp.interfaces.IPyXMPPHelper.__bases__
pyxmpp.interfaces.IStanzaHandlersProvider.__bases__
zope.interface.Interface.__bases__" class="py-name" href="#" onclick="return doclink('link-17', '__bases__', 'link-11');">__bases__</a></tt><tt class="py-op">:</tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt id="link-18" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-18', 'interface', 'link-0');">interface</a></tt> <tt class="py-keyword">in</tt> <tt id="link-19" class="py-name" targets="Function pyxmpp.interface.implementedBy()=pyxmpp.interface-module.html#implementedBy,Method pyxmpp.interface_micro_impl.InterfaceClass.implementedBy()=pyxmpp.interface_micro_impl.InterfaceClass-class.html#implementedBy,Function pyxmpp.interface_micro_impl.implementedBy()=pyxmpp.interface_micro_impl-module.html#implementedBy"><a title="pyxmpp.interface.implementedBy
pyxmpp.interface_micro_impl.InterfaceClass.implementedBy
pyxmpp.interface_micro_impl.implementedBy" class="py-name" href="#" onclick="return doclink('link-19', 'implementedBy', 'link-19');">implementedBy</a></tt><tt class="py-op">(</tt><tt class="py-name">base</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line">            <tt class="py-keyword">yield</tt> <tt id="link-20" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-20', 'interface', 'link-0');">interface</a></tt> </tt>
</div><a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line"> </tt>
<a name="providedBy"></a><div id="providedBy-def"><a name="L70"></a><tt class="py-lineno"> 70</tt> <a class="py-toggle" href="#" id="providedBy-toggle" onclick="return toggle('providedBy');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl-module.html#providedBy">providedBy</a><tt class="py-op">(</tt><tt class="py-param">ob</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="providedBy-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="providedBy-expanded"><a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line">    <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt id="link-21" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-21', 'interface', 'link-0');">interface</a></tt> <tt class="py-keyword">in</tt> <tt class="py-name">ob</tt><tt class="py-op">.</tt><tt class="py-name">__provides__</tt><tt class="py-op">:</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">            <tt class="py-keyword">yield</tt> <tt id="link-22" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-22', 'interface', 'link-0');">interface</a></tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">    <tt class="py-keyword">except</tt> <tt class="py-name">AttributeError</tt><tt class="py-op">:</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt id="link-23" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-23', 'interface', 'link-0');">interface</a></tt> <tt class="py-keyword">in</tt> <tt id="link-24" class="py-name"><a title="pyxmpp.interface.implementedBy
pyxmpp.interface_micro_impl.InterfaceClass.implementedBy
pyxmpp.interface_micro_impl.implementedBy" class="py-name" href="#" onclick="return doclink('link-24', 'implementedBy', 'link-19');">implementedBy</a></tt><tt class="py-op">(</tt><tt class="py-name">ob</tt><tt class="py-op">.</tt><tt class="py-name">__class__</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">                <tt class="py-keyword">yield</tt> <tt id="link-25" class="py-name"><a title="pyxmpp.interface
zope.interface.interface.Attribute.interface" class="py-name" href="#" onclick="return doclink('link-25', 'interface', 'link-0');">interface</a></tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt class="py-name">AttributeError</tt><tt class="py-op">:</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> </tt>
</div><a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line"> </tt>
<a name="InterfaceClass"></a><div id="InterfaceClass-def"><a name="L81"></a><tt class="py-lineno"> 81</tt> <a class="py-toggle" href="#" id="InterfaceClass-toggle" onclick="return toggle('InterfaceClass');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.InterfaceClass-class.html">InterfaceClass</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="InterfaceClass-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="InterfaceClass-expanded"><a name="InterfaceClass.__init__"></a><div id="InterfaceClass.__init__-def"><a name="L82"></a><tt class="py-lineno"> 82</tt> <a class="py-toggle" href="#" id="InterfaceClass.__init__-toggle" onclick="return toggle('InterfaceClass.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.InterfaceClass-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">name</tt><tt class="py-op">,</tt> <tt class="py-param">bases</tt> <tt class="py-op">=</tt> <tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> <tt class="py-param">attrs</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">,</tt> <tt class="py-param">__doc__</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">,</tt> <tt class="py-param">__module__</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="InterfaceClass.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="InterfaceClass.__init__-expanded"><a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">__module__</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-op">(</tt><tt class="py-name">attrs</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt> <tt class="py-keyword">and</tt> <tt class="py-op">(</tt><tt class="py-string">'__module__'</tt> <tt class="py-keyword">in</tt> <tt class="py-name">attrs</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">attrs</tt><tt class="py-op">[</tt><tt class="py-string">'__module__'</tt><tt class="py-op">]</tt><tt class="py-op">,</tt> <tt class="py-name">str</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">                <tt class="py-name">__module__</tt> <tt class="py-op">=</tt> <tt class="py-name">attrs</tt><tt class="py-op">[</tt><tt class="py-string">'__module__'</tt><tt class="py-op">]</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">                <tt class="py-keyword">del</tt> <tt class="py-name">attrs</tt><tt class="py-op">[</tt><tt class="py-string">'__module__'</tt><tt class="py-op">]</tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">                <tt class="py-name">__module__</tt> <tt class="py-op">=</tt> <tt class="py-name">sys</tt><tt class="py-op">.</tt><tt class="py-name">_getframe</tt><tt class="py-op">(</tt><tt class="py-number">1</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">f_globals</tt><tt class="py-op">[</tt><tt class="py-string">'__name__'</tt><tt class="py-op">]</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">__doc__</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__doc__</tt> <tt class="py-op">=</tt> <tt class="py-name">__doc__</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">attrs</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt> <tt class="py-keyword">and</tt> <tt class="py-string">"__doc__"</tt> <tt class="py-keyword">in</tt> <tt class="py-name">attrs</tt><tt class="py-op">:</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">            <tt class="py-keyword">del</tt> <tt class="py-name">attrs</tt><tt class="py-op">[</tt><tt class="py-string">"__doc__"</tt><tt class="py-op">]</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__module__</tt> <tt class="py-op">=</tt> <tt class="py-name">__module__</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">base</tt> <tt class="py-keyword">in</tt> <tt class="py-name">bases</tt><tt class="py-op">:</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">base</tt><tt class="py-op">,</tt> <tt id="link-26" class="py-name"><a title="pyxmpp.interface_micro_impl.InterfaceClass" class="py-name" href="#" onclick="return doclink('link-26', 'InterfaceClass', 'link-3');">InterfaceClass</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line">                <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">'Interface bases must be Interfaces'</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">attrs</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">aname</tt><tt class="py-op">,</tt> <tt class="py-name">attr</tt> <tt class="py-keyword">in</tt> <tt class="py-name">attrs</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoItems.items=pyxmpp.jabber.disco.DiscoItems-class.html#items,Variable pyxmpp.roster.Roster.items=pyxmpp.roster.Roster-class.html#items"><a title="pyxmpp.jabber.disco.DiscoItems.items
pyxmpp.roster.Roster.items" class="py-name" href="#" onclick="return doclink('link-27', 'items', 'link-27');">items</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">attr</tt><tt class="py-op">,</tt> <tt id="link-28" class="py-name" targets="Class pyxmpp.interface_micro_impl.Attribute=pyxmpp.interface_micro_impl.Attribute-class.html,Class zope.interface.interface.Attribute=zope.interface.interface.Attribute-class.html"><a title="pyxmpp.interface_micro_impl.Attribute
zope.interface.interface.Attribute" class="py-name" href="#" onclick="return doclink('link-28', 'Attribute', 'link-28');">Attribute</a></tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt id="link-29" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoIdentity.type=pyxmpp.jabber.disco.DiscoIdentity-class.html#type"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-29', 'type', 'link-29');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">attr</tt><tt class="py-op">)</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">FunctionType</tt><tt class="py-op">:</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line">                    <tt class="py-keyword">raise</tt> <tt class="py-name">TypeError</tt><tt class="py-op">,</tt> <tt class="py-string">'Interface attributes must be Attributes o functions (%r found in %s)'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">attr</tt><tt class="py-op">,</tt> <tt class="py-name">aname</tt><tt class="py-op">)</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-30" class="py-name"><a title="pyxmpp.interfaces.IFeaturesProvider.__bases__
pyxmpp.interfaces.IIqHandlersProvider.__bases__
pyxmpp.interfaces.IMessageHandlersProvider.__bases__
pyxmpp.interfaces.IPresenceHandlersProvider.__bases__
pyxmpp.interfaces.IPyXMPPHelper.__bases__
pyxmpp.interfaces.IStanzaHandlersProvider.__bases__
zope.interface.Interface.__bases__" class="py-name" href="#" onclick="return doclink('link-30', '__bases__', 'link-11');">__bases__</a></tt> <tt class="py-op">=</tt> <tt class="py-name">bases</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__attrs</tt> <tt class="py-op">=</tt> <tt class="py-name">attrs</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-31" class="py-name" targets="Variable pyxmpp.interfaces.IFeaturesProvider.__name__=pyxmpp.interfaces.IFeaturesProvider-class.html#__name__,Variable pyxmpp.interfaces.IIqHandlersProvider.__name__=pyxmpp.interfaces.IIqHandlersProvider-class.html#__name__,Variable pyxmpp.interfaces.IMessageHandlersProvider.__name__=pyxmpp.interfaces.IMessageHandlersProvider-class.html#__name__,Variable pyxmpp.interfaces.IPresenceHandlersProvider.__name__=pyxmpp.interfaces.IPresenceHandlersProvider-class.html#__name__,Variable pyxmpp.interfaces.IPyXMPPHelper.__name__=pyxmpp.interfaces.IPyXMPPHelper-class.html#__name__,Variable pyxmpp.interfaces.IStanzaHandlersProvider.__name__=pyxmpp.interfaces.IStanzaHandlersProvider-class.html#__name__,Variable zope.interface.Interface.__name__=zope.interface.Interface-class.html#__name__"><a title="pyxmpp.interfaces.IFeaturesProvider.__name__
pyxmpp.interfaces.IIqHandlersProvider.__name__
pyxmpp.interfaces.IMessageHandlersProvider.__name__
pyxmpp.interfaces.IPresenceHandlersProvider.__name__
pyxmpp.interfaces.IPyXMPPHelper.__name__
pyxmpp.interfaces.IStanzaHandlersProvider.__name__
zope.interface.Interface.__name__" class="py-name" href="#" onclick="return doclink('link-31', '__name__', 'link-31');">__name__</a></tt> <tt class="py-op">=</tt> <tt id="link-32" class="py-name" targets="Variable pyxmpp.all.name=pyxmpp.all-module.html#name,Variable pyxmpp.interfaces.name=pyxmpp.interfaces-module.html#name,Variable pyxmpp.jabber.all.name=pyxmpp.jabber.all-module.html#name,Variable pyxmpp.jabber.disco.DiscoIdentity.name=pyxmpp.jabber.disco.DiscoIdentity-class.html#name,Variable pyxmpp.jabber.disco.DiscoItem.name=pyxmpp.jabber.disco.DiscoItem-class.html#name,Variable pyxmpp.jabberd.all.name=pyxmpp.jabberd.all-module.html#name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-32', 'name', 'link-32');">name</a></tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-33" class="py-name" targets="Variable pyxmpp.interfaces.IFeaturesProvider.__identifier__=pyxmpp.interfaces.IFeaturesProvider-class.html#__identifier__,Variable pyxmpp.interfaces.IIqHandlersProvider.__identifier__=pyxmpp.interfaces.IIqHandlersProvider-class.html#__identifier__,Variable pyxmpp.interfaces.IMessageHandlersProvider.__identifier__=pyxmpp.interfaces.IMessageHandlersProvider-class.html#__identifier__,Variable pyxmpp.interfaces.IPresenceHandlersProvider.__identifier__=pyxmpp.interfaces.IPresenceHandlersProvider-class.html#__identifier__,Variable pyxmpp.interfaces.IPyXMPPHelper.__identifier__=pyxmpp.interfaces.IPyXMPPHelper-class.html#__identifier__,Variable pyxmpp.interfaces.IStanzaHandlersProvider.__identifier__=pyxmpp.interfaces.IStanzaHandlersProvider-class.html#__identifier__,Variable zope.interface.Interface.__identifier__=zope.interface.Interface-class.html#__identifier__"><a title="pyxmpp.interfaces.IFeaturesProvider.__identifier__
pyxmpp.interfaces.IIqHandlersProvider.__identifier__
pyxmpp.interfaces.IMessageHandlersProvider.__identifier__
pyxmpp.interfaces.IPresenceHandlersProvider.__identifier__
pyxmpp.interfaces.IPyXMPPHelper.__identifier__
pyxmpp.interfaces.IStanzaHandlersProvider.__identifier__
zope.interface.Interface.__identifier__" class="py-name" href="#" onclick="return doclink('link-33', '__identifier__', 'link-33');">__identifier__</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"%s.%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__module__</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-34" class="py-name"><a title="pyxmpp.interfaces.IFeaturesProvider.__name__
pyxmpp.interfaces.IIqHandlersProvider.__name__
pyxmpp.interfaces.IMessageHandlersProvider.__name__
pyxmpp.interfaces.IPresenceHandlersProvider.__name__
pyxmpp.interfaces.IPyXMPPHelper.__name__
pyxmpp.interfaces.IStanzaHandlersProvider.__name__
zope.interface.Interface.__name__" class="py-name" href="#" onclick="return doclink('link-34', '__name__', 'link-31');">__name__</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">         </tt>
<a name="InterfaceClass.providedBy"></a><div id="InterfaceClass.providedBy-def"><a name="L106"></a><tt class="py-lineno">106</tt> <a class="py-toggle" href="#" id="InterfaceClass.providedBy-toggle" onclick="return toggle('InterfaceClass.providedBy');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.InterfaceClass-class.html#providedBy">providedBy</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">ob</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="InterfaceClass.providedBy-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="InterfaceClass.providedBy-expanded"><a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">        <tt class="py-docstring">"""Is the interface implemented by an object"""</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt> <tt class="py-keyword">in</tt> <tt id="link-35" class="py-name" targets="Function pyxmpp.interface.providedBy()=pyxmpp.interface-module.html#providedBy,Method pyxmpp.interface_micro_impl.InterfaceClass.providedBy()=pyxmpp.interface_micro_impl.InterfaceClass-class.html#providedBy,Function pyxmpp.interface_micro_impl.providedBy()=pyxmpp.interface_micro_impl-module.html#providedBy"><a title="pyxmpp.interface.providedBy
pyxmpp.interface_micro_impl.InterfaceClass.providedBy
pyxmpp.interface_micro_impl.providedBy" class="py-name" href="#" onclick="return doclink('link-35', 'providedBy', 'link-35');">providedBy</a></tt><tt class="py-op">(</tt><tt class="py-name">ob</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">True</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
</div><a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line"> </tt>
<a name="InterfaceClass.implementedBy"></a><div id="InterfaceClass.implementedBy-def"><a name="L112"></a><tt class="py-lineno">112</tt> <a class="py-toggle" href="#" id="InterfaceClass.implementedBy-toggle" onclick="return toggle('InterfaceClass.implementedBy');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.InterfaceClass-class.html#implementedBy">implementedBy</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">cls</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="InterfaceClass.implementedBy-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="InterfaceClass.implementedBy-expanded"><a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">        <tt class="py-docstring">"""Do instances of the given class implement the interface?"""</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt> <tt class="py-keyword">in</tt> <tt id="link-36" class="py-name"><a title="pyxmpp.interface.implementedBy
pyxmpp.interface_micro_impl.InterfaceClass.implementedBy
pyxmpp.interface_micro_impl.implementedBy" class="py-name" href="#" onclick="return doclink('link-36', 'implementedBy', 'link-19');">implementedBy</a></tt><tt class="py-op">(</tt><tt class="py-name">cls</tt><tt class="py-op">)</tt> </tt>
</div><a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"> </tt>
<a name="InterfaceClass.__repr__"></a><div id="InterfaceClass.__repr__-def"><a name="L116"></a><tt class="py-lineno">116</tt> <a class="py-toggle" href="#" id="InterfaceClass.__repr__-toggle" onclick="return toggle('InterfaceClass.__repr__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.InterfaceClass-class.html#__repr__">__repr__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="InterfaceClass.__repr__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="InterfaceClass.__repr__-expanded"><a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line">        <tt id="link-37" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-37', 'name', 'link-32');">name</a></tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-38" class="py-name"><a title="pyxmpp.interfaces.IFeaturesProvider.__name__
pyxmpp.interfaces.IIqHandlersProvider.__name__
pyxmpp.interfaces.IMessageHandlersProvider.__name__
pyxmpp.interfaces.IPresenceHandlersProvider.__name__
pyxmpp.interfaces.IPyXMPPHelper.__name__
pyxmpp.interfaces.IStanzaHandlersProvider.__name__
zope.interface.Interface.__name__" class="py-name" href="#" onclick="return doclink('link-38', '__name__', 'link-31');">__name__</a></tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line">        <tt class="py-name">module</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__module__</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">module</tt> <tt class="py-keyword">and</tt> <tt class="py-name">module</tt> <tt class="py-op">!=</tt> <tt class="py-string">"__main__"</tt><tt class="py-op">:</tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line">            <tt id="link-39" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-39', 'name', 'link-32');">name</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"%s.%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">module</tt><tt class="py-op">,</tt> <tt id="link-40" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-40', 'name', 'link-32');">name</a></tt><tt class="py-op">)</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-string">"&lt;%s %s&gt;"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__class__</tt><tt class="py-op">.</tt><tt id="link-41" class="py-name"><a title="pyxmpp.interfaces.IFeaturesProvider.__name__
pyxmpp.interfaces.IIqHandlersProvider.__name__
pyxmpp.interfaces.IMessageHandlersProvider.__name__
pyxmpp.interfaces.IPresenceHandlersProvider.__name__
pyxmpp.interfaces.IPyXMPPHelper.__name__
pyxmpp.interfaces.IStanzaHandlersProvider.__name__
zope.interface.Interface.__name__" class="py-name" href="#" onclick="return doclink('link-41', '__name__', 'link-31');">__name__</a></tt><tt class="py-op">,</tt> <tt id="link-42" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-42', 'name', 'link-32');">name</a></tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"> </tt>
<a name="Attribute"></a><div id="Attribute-def"><a name="L123"></a><tt class="py-lineno">123</tt> <a class="py-toggle" href="#" id="Attribute-toggle" onclick="return toggle('Attribute');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.Attribute-class.html">Attribute</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Attribute-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="Attribute-expanded"><a name="Attribute.__init__"></a><div id="Attribute.__init__-def"><a name="L124"></a><tt class="py-lineno">124</tt> <a class="py-toggle" href="#" id="Attribute.__init__-toggle" onclick="return toggle('Attribute.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.interface_micro_impl.Attribute-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">doc</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Attribute.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Attribute.__init__-expanded"><a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__doc__</tt> <tt class="py-op">=</tt> <tt id="link-43" class="py-name" targets="Method pyxmpp.xmlextra.StreamReader.doc()=pyxmpp.xmlextra.StreamReader-class.html#doc"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-43', 'doc', 'link-43');">doc</a></tt> </tt>
</div></div><a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line"> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line"><tt id="link-44" class="py-name" targets="Variable pyxmpp.interface_micro_impl.Interface=pyxmpp.interface_micro_impl-module.html#Interface,Class zope.interface.Interface=zope.interface.Interface-class.html"><a title="pyxmpp.interface_micro_impl.Interface
zope.interface.Interface" class="py-name" href="#" onclick="return doclink('link-44', 'Interface', 'link-44');">Interface</a></tt> <tt class="py-op">=</tt> <tt id="link-45" class="py-name"><a title="pyxmpp.interface_micro_impl.InterfaceClass" class="py-name" href="#" onclick="return doclink('link-45', 'InterfaceClass', 'link-3');">InterfaceClass</a></tt><tt class="py-op">(</tt><tt class="py-string">"Interface"</tt><tt class="py-op">,</tt> <tt class="py-name">__module__</tt> <tt class="py-op">=</tt> <tt class="py-string">"pyxmpp.inteface_micro_impl"</tt><tt class="py-op">)</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:09 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
